﻿Imports System.Runtime.InteropServices

Module RA_DLL

    <DllImport("RobotArm.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function RA_ComOpen(ByVal Port As Byte) As Byte
    End Function

    <DllImport("RobotArm.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function RA_ComClose(ByVal Port As Byte) As Byte
    End Function

    <DllImport("RobotArm.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function RA_GetAPIVersion(ByVal Port As Byte) As Byte
    End Function


    <DllImport("RobotArm.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function RA_LEDWrite(ByVal Port As Byte, ByVal Value As Byte) As Byte
    End Function

    <DllImport("RobotArm.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function RA_LEDOn(ByVal Port As Byte, ByVal index As Byte) As Byte
    End Function

    <DllImport("RobotArm.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function RA_LEDOff(ByVal Port As Byte, ByVal index As Byte) As Byte
    End Function


    <DllImport("RobotArm.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function RA_SetServo(ByVal Port As Byte, ByVal index As Byte, ByVal position As Byte) As Byte
    End Function

    <DllImport("RobotArm.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function RA_SetAllServos(ByVal Port As Byte, ByVal position0 As Byte, ByVal position1 As Byte, ByVal position2 As Byte, ByVal position3 As Byte, ByVal position4 As Byte) As Byte
    End Function

    <DllImport("RobotArm.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function RA_GripperClose(ByVal Port As Byte, ByVal strength As Byte) As Byte
    End Function

    <DllImport("RobotArm.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function RA_GripperOpen(ByVal Port As Byte) As Byte
    End Function

    <DllImport("RobotArm.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function RA_Park(ByVal Port As Byte) As Byte
    End Function

    <DllImport("RobotArm.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function RA_StoreCoords(ByVal Port As Byte, ByVal index As Byte, ByVal position0 As Byte, ByVal position1 As Byte, ByVal position2 As Byte, ByVal position3 As Byte, ByVal position4 As Byte) As Byte
    End Function

    <DllImport("RobotArm.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function RA_StorePosition(ByVal Port As Byte, ByVal index As Byte) As Byte
    End Function

    <DllImport("RobotArm.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function RA_GotoPosition(ByVal Port As Byte, ByVal index As Byte) As Byte
    End Function


    <DllImport("RobotArm.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function RA_ReadSwitch(ByVal Port As Byte, ByVal index As Byte) As Byte
    End Function

    <DllImport("RobotArm.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function RA_ReadLight(ByVal Port As Byte) As Byte
    End Function

    <DllImport("RobotArm.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function RA_ReadPot(ByVal Port As Byte) As Byte
    End Function

    <DllImport("RobotArm.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function RA_ReadPressure(ByVal Port As Byte) As Byte
    End Function

    <DllImport("RobotArm.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function RA_ReadColour(ByVal Port As Byte) As Integer
    End Function

    <DllImport("RobotArm.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function RA_ReadColourChannel(ByVal Port As Byte, ByVal index As Byte, ByVal colour As Integer) As Byte
    End Function


    <DllImport("RobotArm.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function RA_LCDClear(ByVal Port As Byte) As Byte
    End Function

    <DllImport("RobotArm.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function RA_LCDPrintString(ByVal Port As Byte, ByVal Text As Byte()) As Byte
    End Function

    <DllImport("RobotArm.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function RA_LCDNumber(ByVal Port As Byte, ByVal Number As Integer) As Byte
    End Function

    <DllImport("RobotArm.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function RA_LCDCursor(ByVal Port As Byte, ByVal X As Byte, ByVal Y As Byte) As Byte
    End Function

    <DllImport("RobotArm.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function RA_LCDClearLine(ByVal Port As Byte, ByVal line As Byte) As Byte
    End Function



    'String Conversion macros

    Public Function RA_LCDPrint(ByVal Port As Byte, ByRef Text As String) As Byte
        RA_LCDPrintString(Port, System.Text.Encoding.UTF8.GetBytes(Text))
    End Function


End Module
